import dds
import ddsutil
import std_msgs/msg/Header_.std_msgs.msg.dds_
import struct

class TransformStamped___TypeSupport(dds.TypeSupport):

    _typename = 'geometry_msgs::msg::dds_::TransformStamped_'
    _keylist = ''
    _metadescriptor = '<MetaData version="1.0.0"><Module name="geometry_msgs"><Module name="msg"><Module name="dds_"><Struct name="Vector3_"><Member name="x_"><Double/></Member><Member name="y_"><Double/></Member><Member name="z_"><Double/></Member></Struct><Struct name="Quaternion_"><Member name="x_"><Double/></Member><Member name="y_"><Double/></Member><Member name="z_"><Double/></Member><Member name="w_"><Double/></Member></Struct><Struct name="Transform_"><Member name="translation_"><Type name="Vector3_"/></Member><Member name="rotation_"><Type name="Quaternion_"/></Member></Struct></Module></Module></Module><Module name="builtin_interfaces"><Module name="msg"><Module name="dds_"><Struct name="Time_"><Member name="sec_"><Long/></Member><Member name="nanosec_"><ULong/></Member></Struct></Module></Module></Module><Module name="std_msgs"><Module name="msg"><Module name="dds_"><Struct name="Header_"><Member name="stamp_"><Type name="::builtin_interfaces::msg::dds_::Time_"/></Member><Member name="frame_id_"><String/></Member></Struct></Module></Module></Module><Module name="geometry_msgs"><Module name="msg"><Module name="dds_"><Struct name="TransformStamped_"><Member name="header_"><Type name="::std_msgs::msg::dds_::Header_"/></Member><Member name="child_frame_id_"><String/></Member><Member name="transform_"><Type name="Transform_"/></Member></Struct></Module></Module></Module></MetaData>'

    def __init__(self):
        super(TransformStamped___TypeSupport, self).__init__(self._typename,
              self._keylist,
              self._metadescriptor,
              struct.calcsize(TransformStamped_()._get_packing_fmt()))

    def _serialize(self, o):
        if not isinstance(o, TransformStamped_):
            raise TypeError('Incorrect data type')
        result = o._serialize()
        return result

    def _deserialize(self, buf):
        result = TransformStamped_()
        data = struct.unpack(result._get_packing_fmt(), buf)
        result._deserialize(list(data))
        return result

class TransformStamped_(ddsutil.TopicDataClass):

    @staticmethod
    def get_type_support():
        ''' Return type support information required for dds.Topic constructor '''
        return TransformStamped___TypeSupport()

    @property
    def header_(self):
        '''
        a DDS std_msgs::msg::dds_::Header_ value
        @rtype: std_msgs/msg/Header_.std_msgs.msg.dds_.Header_
        '''
        return self._header__

    _header__checker = ddsutil._class_checker(std_msgs/msg/Header_.std_msgs.msg.dds_.Header_)
    @header_.setter
    def header_(self, value):
        self._header__checker(value)
        self._header__ = value

    @property
    def child_frame_id_(self):
        '''
        a DDS string value
        @rtype: str
        '''
        return self._child_frame_id__

    _child_frame_id__checker = ddsutil._str_checker
    @child_frame_id_.setter
    def child_frame_id_(self, value):
        self._child_frame_id__checker(value)
        self._child_frame_id__ = value

    @property
    def transform_(self):
        '''
        a DDS geometry_msgs::msg::dds_::Transform_ value
        @rtype: Transform_
        '''
        return self._transform__

    _transform__checker = ddsutil._class_checker(Transform_)
    @transform_.setter
    def transform_(self, value):
        self._transform__checker(value)
        self._transform__ = value

    _member_attributes = ('header_', 'child_frame_id_', 'transform_')

    def __init__(self, **kwargs):
        ''' Create a TransformStamped_ instance, optionally initializing fields by name '''
        # init attributes to default value
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()
        self.child_frame_id_ = ''
        self.transform_ = Transform_()
        # set values for attributes passed in
        for key, value in kwargs.items():
            if key not in self._member_attributes:
                raise TypeError('Invalid argument name : %s' %(key))
            setattr(self, key, value)

    _packing_fmt = None

    @staticmethod
    def _get_packing_fmt():
        ''' Returns packing format of this class data '''
        if TransformStamped_._packing_fmt is not None:
            return TransformStamped_._packing_fmt
        fmt = ''
        fmt += ddsutil._align(fmt, std_msgs/msg/Header_.std_msgs.msg.dds_.Header_._get_packing_fmt())
        fmt += 'P'
        fmt += ddsutil._align(fmt, Transform_._get_packing_fmt())

        TransformStamped_._packing_fmt = ddsutil._pad_fmt(fmt)
        return TransformStamped_._packing_fmt

    def _serialize(self):
        ''' Serialize data for writing '''
        fmt = self._get_packing_fmt()
        args = self._get_packing_args()
        result = struct.pack(fmt, *args)
        return result

    def _deserialize(self, data):
        ''' Initialize values from data returned by struct.unpack()'''
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()._deserialize(data)
        self.child_frame_id_ = ddsutil._ptr_to_bytes(data.pop(0)).decode('ISO-8859-1')
        self.transform_ = Transform_()._deserialize(data)
        return self;

    def _get_packing_args(self):
        ''' Return an list of data suitable for struct.pack '''
        args = []
        args.extend(self.header_._get_packing_args())
        args.append(ddsutil._bytes_to_ptr(self.child_frame_id_.encode('ISO-8859-1')))
        args.extend(self.transform_._get_packing_args())
        return args

